/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#ifndef _SERVER_THREADS_
#define _SERVER_THREADS_


#include <fstream>
using namespace std;
#include "serverObj.h"
#include "rBufferHelper.h"
#include "convertUtil.h"


#define MAX_BUF_LEN                     4096            // max command length
#define WAIT_FOR_NEW_DATA_CONN_TIMEOUT  1 * 60 * 1000   // wait 1 minute for incoming data connection
#define WAIT_FOR_NEXT_CMD_TIMEOUT       1 * 60 * 1000   // wait 1 minute for next command in session


//
// error constants for session threads
//
#define SESSION_THREAD_ERR_NOERR    +0
#define SESSION_THREAD_ERR_WRITE    -1
#define SESSION_THREAD_ERR_READ     -2
#define SESSION_THREAD_ERR_TIMEOUT  -3
#define SESSION_THREAD_ERR_CL_ADDR  -4


//
// return constants for "unsigned int waitForDataConnArrival(LPVOID args, dataConnHandle *dch)"
//
#define WAITFORDATACONN_ERR_NOERR           +0
#define WAITFORDATACONN_ERR_TIMEOUT         -1
#define WAITFORDATACONN_ERR_GLOBAL_FINISH   -2


//
// structs, used to parse information to a thread
//
struct listenThreadInfo {
    ServerObj *svObj;           // server object
    SOCKET *ctrlListenSock;     // handle to controle port
    SOCKET *dataListenSock;     // handle to data port
};

struct threadInfo {
    ServerObj *svObj;           // server object
    SOCKET *sck;                // connection to hanlde
};


DWORD WINAPI listenThread(LPVOID args);             // hanlde incoming connections. 
                                                    // starts one new thread per controle connection and
                                                    // registers data connections with matching handles
DWORD WINAPI sessionThread(LPVOID args);            // functional core of the server


void getNextCommand(string *buffer, string *command);   //searches for the next command in given buffer
bool isCommand(string *strIs, string *strShouldBe);     // Does strIs begin whith strShouldBe ?
                                                        // If yes, remove beginning and return true.

// requests a data connection handle and waits, till it gets active
bool getActiveHandle(LPVOID args, SOCKET *controleSock, dataConnHandle **dch);
int waitForDataConnArrival(LPVOID args, dataConnHandle *dch);   // wait till a expected data connection arives,
                                                                // global finish is requested or 
                                                                // the timeout is reached


#endif _SERVER_THREADS_
