/*

    sftpd - meant to be a small and flexible ftp server implementation
    Copyright (C) 2009  Jan Murawski  der@oelgoetze.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

    For more information about the GNU Public license see:
    http://www.gnu.org/copyleft/gpl.html

*/

#ifndef _SOCKET_HELPER_
#define _SOCKET_HELPER_

#include <winsock.h>
#include <string>
using namespace std;
#include "serverObj.h"
#include <assert.h>


#define SENDTOSOCKET(sck, data) \
        sendToSocket(sck, data, sizeof(data))
#define SENDTOSOCKETLN(sck, data) \
        sendToSocket(sck, data "\r\n", sizeof(data) +2)


bool readFromSocket(SOCKET *sck, string *buffer);       // read from winsock while there are bytes to read 
                                                        // and buffer does not exceed given size
bool sendToSocket(SOCKET *sck, char *buffer, int len);  // send buffer to winsock
bool sendToSocket(SOCKET *sck, string buffer);
bool sendToSocketLn(SOCKET *sck, string buffer);        // same with newline

// use the define SENDTOSOCKETLN(sck, data) instead of
// bool sendToSocketLn(SOCKET *sck, char *buffer, int len);

bool getLocalSockIp(SOCKET *sck, char **peername);      // get the local ip of a connected socket
bool getLocalSockIp(SOCKET *sck, string &peername);
bool getRemoteSockIp(SOCKET *sck, char **peername);     // get the remote ip of a connected socket



#endif _SOCKET_HELPER_
